#!/bin/bash


line=$1

grodir=$3
mutdir=$4
workdir=$5
home_dir=$6/parallel_pipeline

scwrl=$home_dir/"Scwrl4/scwrl"
ligand=$home_dir/"tools/roc.pdb"


#str="${line}q;d"

#sed $str $mutdir | awk '{print $1}' > $workdir/sequence.dat

$scwrl -i $home_dir/concoord_ensemble/c_$2.pdb -o $workdir/$1.pdb -s $workdir/../mutant.seq -f $ligand  >/dev/null

name=$workdir/$1.pdb

sed -i 's/SER A  82/SEO A  82/' $name
sed -i '/HG  SEO/d' $name
sed -i 's/OG  SEO.*/OG  SEO A  82       1.817  -1.774  44.226  1.00                 O/' $name
#sed -i 's/OXT LEU A 285/OC2 LEU A 285/g' $name
#sed -i 's/O   LEU A 285/OC1 LEU A 285/g' $name
$grodir/pdb2gmx -f $name -ff dc_amber99sb-ildn -water none -ignh -o $workdir/conf.gro -p $workdir/topol.top -i $workdir/posre.itp  > /dev/null 2>&1

python2.7 $home_dir/tools/update_topol.py $workdir/topol.top > $workdir/top.top
python2.7 $home_dir/tools/update_conf.py $workdir/conf.gro > $workdir/c.gro

sed "s|./dc_amber99sb-ildn.ff/forcefield.itp|$(pwd)/dc_amber99sb-ildn.ff/forcefield.itp|g" $workdir/top.top > $workdir/topol.top

mv $workdir/c.gro $workdir/conf.gro

$grodir/grompp -f $home_dir/tools/em_implicit.mdp -c $workdir/conf.gro -p $workdir/topol.top -o $workdir/em.tpr -po $workdir/mdout.mdp > /dev/null 2>&1
$grodir/mdrun -deffnm $workdir/em -nt 1  > /dev/null 2>&1

rm $workdir/*.pdb $workdir/em.tpr $workdir/mdout.mdp $workdir/posre.itp $workdir/top.top $workdir/topol.top


