import time
import os
import subprocess as sb
import random
import datetime
import sys
sequence =  sys.argv[1]
#number of threads to start on node
cpu_num = 16

#define all the paths that are important for the bash scripts, for jubio
gromacs_dir = "/usr/users/iff_th2/corte/gromacs_andre/bin"
main_savedir = "/local/jubio/dellacorte/1EX9/test"
home_dir = '/usr/users/iff_th2/corte/20140803'
#on the local machine
#gromacs_dir = "/usr/bin"
#main_savedir = "/home/dellacorte/PhD/1EX9/test/Energy_barrier_data"

#on JUROPA
#home_dir = "/lustre/jhome17/jics65/jics6500"

#gromacs_dir = "/usr/local/gromacs/4.5.3/bin"
#main_savedir = "/lustre/jhome17/jics65/jics6500/results"


mutant_dir = home_dir+"/parallel_pipeline/tools/50_n_mut.dat"


#make sure that Scwrl is correctly installed. Need to update Scwrl4.ini
#scwrlinstdir = (os.getcwd()+'/Scwrl4/')
#with open(scwrlinstdir+"Scwrl4.ini") as f:
#    data = f.readlines()
#f = open(scwrlinstdir+"Scwrl4.ini",'w')
#for i in range(len(data)):
#    if data[i].find("FilePath") == 1:
#        data[i] = "	FilePath  =  "+ scwrlinstdir+"bbDepRotLib.bin\n"
#    f.write("%s" % data[i])
#f.close()

#create the main savdir directory
if not os.path.exists(main_savedir):
    os.makedirs(main_savedir)
    
cov_savedir = main_savedir+'/covalent_ligand'
noncov_savedir = main_savedir+'/non_covalent_ligand'
if not os.path.exists(cov_savedir):
    os.makedirs(cov_savedir)
if not os.path.exists(noncov_savedir):
    os.makedirs(noncov_savedir)

#with open(mutant_dir) as f:
#        f = f.readlines()
seq_list = list(sequence.upper())
m = list('STYTQTKYPIVLAHGMLGFDNILGVDYWFGIPSALRRDGAQVYVTEVSQLDTSEVRGEQLLQQVEEIVALSGQPKVNLIGHSHGGPTIRYVAAVRPDLIASATSVGAPHKGSDTADFLRQIPPGSAGEAVLSGLVNSLGALISFLSSGSTGTQNSLGSLESLNSEGAARFNAKYPQGIPTSACGEGAYKVNGVSYYSWSGSSPLTNFLDPSDAFLGASSLTFKNGTANDGLVGTCSSHLGMVIRDNYRMNHLDEVNQVFGLTSLFETSPVSVYRQHANRLKNASL')


name = ''
for i in range(len(m)):
    if seq_list[i] != m[i]:
        name += str(m[i]+str(i)+ seq_list[i]+'_')


queue = []
print 'Create the queue'
for i in range(1,2):
    #create a directory subfolder for each mutant in the cov and noncov directories
    cov_mut_dir = cov_savedir+'/'+name+'sim'
    noncov_mut_dir = noncov_savedir+'/'+name+'sim'
    if not os.path.exists(cov_mut_dir):
        os.makedirs(cov_mut_dir)
    if not os.path.exists(noncov_mut_dir):
        os.makedirs(noncov_mut_dir)
    with open(cov_mut_dir+'/mutant.seq','w') as sf:
        sf.write(sequence)
    with open(noncov_mut_dir+'/mutant.seq','w') as sf:
        sf.write(sequence)    
    for ii in range(1,97):#loop of concoord ensemble
        #send the individuall jobs to the cores. Have each calculation in a subsubfolder
        calc_cov_dir = cov_mut_dir+'/'+str(ii)
        calc_noncov_dir = noncov_mut_dir+'/'+str(ii)
        if not os.path.exists(calc_cov_dir):
            os.makedirs(calc_cov_dir)
        queue.append(('bash '+home_dir+'/parallel_pipeline/cov_ensemble_em.sh '    +str(i)+' '+str(ii)+' '+gromacs_dir+' '+mutant_dir+' '+calc_cov_dir +' '+home_dir))
        if not os.path.exists(calc_noncov_dir):
            os.makedirs(calc_noncov_dir)
        queue.append(('bash '+home_dir+'/parallel_pipeline/non_cov_ensemble_em.sh '+str(i)+' '+str(ii)+' '+gromacs_dir+' '+mutant_dir+' '+calc_noncov_dir+' '+home_dir))



print 'Start the calculation'
#simple paralyzed code to get the scripts runnin' on a cluster

jobs = [sb.Popen(queue[i],shell=True) for i in range(cpu_num)]
job_ctr = cpu_num

while job_ctr < len(queue):
    for i in range(len(jobs)):
        if jobs[i].poll() != None:
            jobs[i] = sb.Popen(queue[job_ctr] , shell = True)
            job_ctr += 1
            print "%.3f percent" % (job_ctr/float(len(queue))*100)
            if job_ctr == len(queue): break
    time.sleep(5)

#here all jobs are in the queue, just make sure that the last one finished
done = False
while not done:
    done = True
    for i in range(len(jobs)):
        if jobs[i].poll() == None:
            #job is running
            done = False
    time.sleep(30)


