#this script takes in the whole topology of the ligand and updates the atom numbers depending on the
#the last number of atoms in the main topology as well as the first atom number of the serine 82

#now load in the hole toplogy to find the two paramters

import sys
path_to_file = sys.argv[1]

shall_distance_restraints = False

with open(path_to_file) as f:
        topol = f.readlines()

ctr = 0
ser = 0
pairs = 0
bonds = 0
angles =0
dih =0
for line in topol:
    ctr += 1
    if line == '; residue  82 SEO rtp SEO  q -0.4\n':
        ser = ctr
    if line == '[ bonds ]\n':
        bonds = ctr
    if line == '[ pairs ]\n':
        pairs = ctr
    if line == '[ angles ]\n':
        angles = ctr
    if line == '[ dihedrals ]\n':
        if dih == 0:
            dih = ctr
    if line == '; Include Position restraint file\n':
        end = ctr
    if line == '[ system ]\n':
        disres = ctr
        break

        
ser = int(topol[ser].split()[0])
ter = int(topol[bonds- 3].split()[0])

og_index = ser + 7
cb_index = ser + 4
ca_index = ser + 2
c4_index = ter + 1 
c6_index = ter +  8
hb2_index = ser + 6
hb1_index = ser + 5
o4_index = ter + 2#04 - c4 - OG 114.61
o5_index = ter + 3#05 - c4 - OG 108.87

'''start a large copy routine that will double the topology and include my updates'''
lines = len(topol)

for i in range(lines):
    print topol[i],
    if i == bonds - 3:
        print '; ligand'
        print '  '+str(ter + 1) + '          C      1    ROC     C4      1     0.566       12.0110'
        print '  '+str(ter + 2) + '          O      1    ROC     O4      1    -0.928       15.9994'
        print '  '+str(ter + 3) + '          O2     1    ROC     O5      1    -0.315       15.9994'
        print '  '+str(ter + 4) + '          C      1    ROC     C5      1    -0.294       12.0110'
        print '  '+str(ter + 5) + '          HA     1    ROC     H3      1     0.113       1.0080'
        print '  '+str(ter + 6) + '          HA     1    ROC     H9      1     0.107       1.0080'
        print '  '+str(ter + 7) + '          HA     1    ROC     H13     1     0.122       1.0080'
        print '  '+str(ter + 8) + '          C      1    ROC     C6      2     0.009       12.0110'
        print '  '+str(ter + 9) + '          HA     1    ROC     H11     2     0.025       1.0080'
        print '  '+str(ter + 10) + '          C      1    ROC     C8      2     0.142       12.0110'
        print '  '+str(ter + 11) + '           HA    1    ROC     H15     2     0.089       1.0080'
        print '  '+str(ter + 12) + '          HA     1    ROC     H16     2     0.013       1.0080'
        print '  '+str(ter + 13) + '          O2     1    ROC     O6      2    -0.637       15.9994'
        print '  '+str(ter + 14) + '          H      1    ROC     H10     2     0.378       1.0080'
        print '  '+str(ter + 15) + '          C      1    ROC     C7      3    -0.183       12.0110'
        print '  '+str(ter + 16) + '          HA     1    ROC     H8      3     0.061       1.0080'
        print '  '+str(ter + 17) + '          HA     1    ROC     H12     3     0.061       1.0080'
        print '  '+str(ter + 18) + '          HA     1    ROC     H14     3     0.061       1.0080'

    if i == pairs - 3:  
        print '; ai  aj  fu    c0, c1, ...'
        print ' '+str(ter + 1) +'  '+ str(ter + 2) +'     1    0.1310    1.6600e+07'
        print ' '+str(ter + 1) +'  '+ str(ter + 3) +'     1    0.1500    1.0200e+07'
        print ' '+str(ter + 1) +'  '+ str(ter + 4) +'     1    0.1570    5.4300e+06' #error! was 8
        print ' '+str(ter + 3) +'  '+ str(ter + 8) +'     1    0.1435    6.1000e+06' #error was 4
        print ' '+str(ter + 8) +'  '+ str(ter + 5) +'     1    0.1100    1.2300e+07'
        print ' '+str(ter + 8) +'  '+ str(ter + 6) +'     1    0.1110    1.2300e+07'
        print ' '+str(ter + 8) +'  '+ str(ter + 7) +'     1    0.1100    1.2300e+07'
        print ' '+str(ter + 4) +'  '+ str(ter + 9) +'     1    0.1110    1.2100e+07'
        print ' '+str(ter + 4) +'  '+ str(ter + 10) +'     1    0.1540    7.1500e+06'
        print ' '+str(ter + 4) +'  '+ str(ter + 15) +'     1    0.1540    7.1500e+06'
        print ' '+str(ter + 10) +'  '+ str(ter + 11) +'     1    0.1100    1.2300e+07'
        print ' '+str(ter + 10) +'  '+ str(ter + 12) +'     1    0.1110    1.2100e+07'
        print ' '+str(ter + 10) +'  '+ str(ter + 13) +'     1    0.1450    8.1800e+06'
        print ' '+str(ter + 13) +'  '+ str(ter + 14) +'     1    0.0980    1.5700e+07'
        print ' '+str(ter + 15) +'  '+ str(ter + 16) +'     1    0.1100    1.2300e+07'
        print ' '+str(ter + 15) +'  '+ str(ter + 17) +'     1    0.1110    1.2100e+07'
        print ' '+str(ter + 15) +'  '+ str(ter + 18) +'     1    0.1100    1.2100e+07'

        print ';ligand and protein connection'
        print ' '+str(og_index) +'  '+ str(c4_index) +'     1    0.155     8.1800e+06'
    if i == angles -3:
        print ';ligand pairs'
        print '; ai  aj  fu    c0, c1, ...'
        print ' '+str(ter + 1) +'  '+ str(ter + 5) +'     1'
        print ' '+str(ter + 1) +'  '+ str(ter + 6) +'     1'
        print ' '+str(ter + 1) +'  '+ str(ter + 7) +'     1'
        print ' '+str(ter + 1) +'  '+ str(ter + 11) +'     1'
        print ' '+str(ter + 1) +'  '+ str(ter + 12) +'     1'
        print ' '+str(ter + 1) +'  '+ str(ter + 13) +'     1'
        print ' '+str(ter + 1) +'  '+ str(ter + 16) +'     1'
        print ' '+str(ter + 1) +'  '+ str(ter + 17) +'     1'
        print ' '+str(ter + 1) +'  '+ str(ter + 18) +'     1'
        print ' '+str(ter + 2) +'  '+ str(ter + 8) +'     1'
        print ' '+str(ter + 2) +'  '+ str(ter + 9) +'     1'
        print ' '+str(ter + 2) +'  '+ str(ter + 10) +'     1'
        print ' '+str(ter + 2) +'  '+ str(ter + 15) +'     1'
        print ' '+str(ter + 3) +'  '+ str(ter + 9) +'     1'
        print ' '+str(ter + 3) +'  '+ str(ter + 10) +'     1'
        print ' '+str(ter + 3) +'  '+ str(ter + 15) +'     1'
        print ' '+str(ter + 4) +'  '+ str(ter + 13) +'     1'
        print ' '+str(ter + 4) +'  '+ str(ter + 8) +'     1'
        print ' '+str(ter + 9) +'  '+ str(ter + 11) +'     1'
        print ' '+str(ter + 9) +'  '+ str(ter + 12) +'     1'
        print ' '+str(ter + 9) +'  '+ str(ter + 13) +'     1'
        print ' '+str(ter + 9) +'  '+ str(ter + 16) +'     1'
        print ' '+str(ter + 9) +'  '+ str(ter + 17) +'     1'
        print ' '+str(ter + 9) +'  '+ str(ter + 18) +'     1'
        print ' '+str(ter + 10) +'  '+ str(ter + 16) +'     1'
        print ' '+str(ter + 10) +'  '+ str(ter + 17) +'     1'
        print ' '+str(ter + 10) +'  '+ str(ter + 18) +'     1'
        print ' '+str(ter + 11) +'  '+ str(ter + 14) +'     1'
        print ' '+str(ter + 11) +'  '+ str(ter + 15) +'     1'
        print ' '+str(ter + 12) +'  '+ str(ter + 14) +'     1'
        print ' '+str(ter + 12) +'  '+ str(ter + 15) +'     1'
        print ' '+str(ter + 13) +'  '+ str(ter + 15) +'     1'

      
        print ';ligand prot !'
		#this should be it!!
        print ' '+str(ter + 8) +'  '+ str(og_index) +'     1'
        print ' '+str(ter + 10) +'  '+ str(og_index) +'     1'
        print ' '+str(ter + 9) +'  '+ str(og_index) +'     1'
        print ' '+str(ter + 15) +'  '+ str(og_index) +'     1'
        print ' '+str(ter + 4) +'  '+ str(cb_index) +'     1'
        print ' '+str(ter + 3) +'  '+ str(cb_index) +'     1'
        print ' '+str(ter + 2) +'  '+ str(cb_index) +'     1'
        print ' '+str(ter + 1) +'  '+ str(ca_index) +'     1'
        print ' '+str(ter + 1) +'  '+ str(hb1_index) +'     1'
        print ' '+str(ter + 1) +'  '+ str(hb2_index) +'     1'

    if i == dih -3:
        print ';[ angles ]'
        print '; ai  aj  ak  fu    c0, c1, ...'
        print ' '+str(ter + 1) +'  '+ str(ter + 3) +'  '+str(ter+8)+'     1    114.16       1080.00'
        print ' '+str(ter + 1) +'  '+ str(ter + 4) +'  '+str(ter+9)+'     1    104.23       465.00'
        print ' '+str(ter + 1) +'  '+ str(ter + 4) +'  '+str(ter+10)+'     1    114.22       507.00'
        print ' '+str(ter + 1) +'  '+ str(ter + 4) +'  '+str(ter+15)+'     1    111.41       530.00'
        print ' '+str(ter + 2) +'  '+ str(ter + 1) +'  '+str(ter+3)+'     1    115.05       730.00'
        print ' '+str(ter + 2) +'  '+ str(ter + 1) +'  '+str(ter+4)+'     1    114.68       730.00'
        print ' '+str(ter + 3) +'  '+ str(ter + 1) +'  '+str(ter+4)+'     1    104.87       530.00'
        print ' '+str(ter + 3) +'  '+ str(ter + 8) +'  '+str(ter+5)+'     1    111.65       618.00'
        print ' '+str(ter + 3) +'  '+ str(ter + 8) +'  '+str(ter+6)+'     1    111.89       524.00'
        print ' '+str(ter + 3) +'  '+ str(ter + 8) +'  '+str(ter+7)+'     1    106.11       524.00'
        print ' '+str(ter + 4) +'  '+ str(ter + 10) +'  '+str(ter+12)+'     1    110.17       739.00'
        print ' '+str(ter + 4) +'  '+ str(ter + 10) +'  '+str(ter+11)+'     1    110.42       739.00'
        print ' '+str(ter + 4) +'  '+ str(ter + 10) +'  '+str(ter+13)+'     1    112.46       739.00'
        print ' '+str(ter + 4) +'  '+ str(ter + 15) +'  '+str(ter+17)+'     1    110.03       739.00'
        print ' '+str(ter + 4) +'  '+ str(ter + 15) +'  '+str(ter+18)+'     1    110.67       739.00'
        print ' '+str(ter + 4) +'  '+ str(ter + 15) +'  '+str(ter+16)+'     1    110.49       739.00'

        print ' '+str(ter + 5) +'  '+ str(ter + 8) +'  '+str(ter+6)+'     1    108.92       739.00'
        print ' '+str(ter + 5) +'  '+ str(ter + 8) +'  '+str(ter+7)+'     1    109.33       524.00'
        print ' '+str(ter + 6) +'  '+ str(ter + 8) +'  '+str(ter+7)+'     1    109.21       524.00'

        print ' '+str(ter + 9) +'  '+ str(ter + 4) +'  '+str(ter+10)+'     1    107.00       842.00'
        print ' '+str(ter + 9) +'  '+ str(ter + 4) +'  '+str(ter+15)+'     1    108.23       842.00'
        print ' '+str(ter + 10) +'  '+ str(ter + 4) +'  '+str(ter+15)+'     1    111.25       530.00'
        print ' '+str(ter + 10) +'  '+ str(ter + 13) +'  '+str(ter+14)+'     1    106.26       443.00'
        print ' '+str(ter + 11) +'  '+ str(ter + 10) +'  '+str(ter+12)+'     1    108.07       484.00'
        print ' '+str(ter + 11) +'  '+ str(ter + 10) +'  '+str(ter+13)+'     1    105.07       503.00'
        print ' '+str(ter + 12) +'  '+ str(ter + 10) +'  '+str(ter+13)+'     1    110.46       450.00'
        print ' '+str(ter + 16) +'  '+ str(ter + 15) +'  '+str(ter+17)+'     1    108.11       618.00'
        print ' '+str(ter + 16) +'  '+ str(ter + 15) +'  '+str(ter+18)+'     1    109.11       285.00'
        print ' '+str(ter + 17) +'  '+ str(ter + 15) +'  '+str(ter+18)+'     1    108.36       842.00'
        print ';protein - ligand !This should be fine!!!!'
        print ' '+str(ter + 1) +'  '+ str(og_index) +'  '+str(cb_index)+'     1    114.20       730.00'        
        print ' '+str(ter + 2) +'  '+ str(ter + 1) +'  '+str(og_index)+'     1    114.20       730.00'        
        print ' '+str(ter + 3) +'  '+ str(ter + 1) +'  '+str(og_index)+'     1     99.14       530.00'
        print ' '+str(ter + 4) +'  '+ str(ter + 1) +'  '+str(og_index)+'     1    107.31       739.00'

    if i == end - 3: 
        print ';[ dihedrals ]' 
        print ';  ai    aj    ak    al funct            c0            c1            c2            c3 '
        print ' '+str(ter + 1) +'  '+ str(ter + 3) +'  '+ str(ter + 8) +'  '+str(ter+5)+'     4    65.18      1.26       2'
        print ' '+str(ter + 1) +'  '+ str(ter + 3) +'  '+ str(ter + 8) +'  '+str(ter+6)+'     4   -57.21      1.26       2'
        print ' '+str(ter + 1) +'  '+ str(ter + 3) +'  '+ str(ter + 8) +'  '+str(ter+7)+'     4   -175.78     1.26       2'
        print ' '+str(ter + 1) +'  '+ str(ter + 4) +'  '+ str(ter + 10) +'  '+str(ter+12)+'     4   -47.49      1.26       2'
        print ' '+str(ter + 1) +'  '+ str(ter + 4) +'  '+ str(ter + 10) +'  '+str(ter+11)+'     4    71.81      1.26       2'
        print ' '+str(ter + 1) +'  '+ str(ter + 4) +'  '+ str(ter + 10) +'  '+str(ter+13)+'     4   -171.18     1.26       2'
        print ' '+str(ter + 1) +'  '+ str(ter + 3) +'  '+ str(ter + 15) +'  '+str(ter+16)+'     4   -179.39     1.26       2'
        print ' '+str(ter + 1) +'  '+ str(ter + 3) +'  '+ str(ter + 15) +'  '+str(ter+17)+'     4   -60.08      1.26       2'
        print ' '+str(ter + 1) +'  '+ str(ter + 3) +'  '+ str(ter + 15) +'  '+str(ter+18)+'     4    59.65      1.26       2'
        print ' '+str(ter + 2) +'  '+ str(ter + 1) +'  '+ str(ter + 3) +'  '+str(ter+8)+'     4    -26.58     7.11       2'
        print ' '+str(ter + 2) +'  '+ str(ter + 1) +'  '+ str(ter + 4) +'  '+str(ter+10)+'     4   -175.88     7.11       2'
        print ' '+str(ter + 2) +'  '+ str(ter + 1) +'  '+ str(ter + 4) +'  '+str(ter+9)+'     4     67.71     7.11       2'
        print ' '+str(ter + 2) +'  '+ str(ter + 1) +'  '+ str(ter + 4) +'  '+str(ter+15)+'     4    -48.79     7.11       2'
        print ' '+str(ter + 3) +'  '+ str(ter + 1) +'  '+ str(ter + 4) +'  '+str(ter+10)+'     4    -48.71     7.11       2' 
        print ' '+str(ter + 3) +'  '+ str(ter + 1) +'  '+ str(ter + 4) +'  '+str(ter+9)+'     4   -165.12     7.11       2' 
        print ' '+str(ter + 3) +'  '+ str(ter + 1) +'  '+ str(ter + 4) +'  '+str(ter+10)+'     4     78.38     7.11       2' 
        print ' '+str(ter + 4) +'  '+ str(ter + 1) +'  '+ str(ter + 3) +'  '+str(ter+8)+'     4   -153.52     7.11       2' 
        print ' '+str(ter + 4) +'  '+ str(ter + 10) +'  '+ str(ter + 13) +'  '+str(ter+14)+'     4     57.30     7.11       2' 
        print ' '+str(ter + 9) +'  '+ str(ter + 4) +'  '+ str(ter + 15) +'  '+str(ter+18)+'     4    -54.38     7.11       2' 
        print ' '+str(ter + 9) +'  '+ str(ter + 4) +'  '+ str(ter + 15) +'  '+str(ter+17)+'     4   -174.11     7.11       2' 
        print ' '+str(ter + 9) +'  '+ str(ter + 4) +'  '+ str(ter + 15) +'  '+str(ter+16)+'     4     66.58     7.11       2' 
        print ' '+str(ter + 9) +'  '+ str(ter + 4) +'  '+ str(ter + 10) +'  '+str(ter+13)+'     4     57.30     7.11       2' 
        print ' '+str(ter + 9) +'  '+ str(ter + 4) +'  '+ str(ter + 10) +'  '+str(ter+12)+'     4     67.30     7.11       2' 
        print ' '+str(ter + 9) +'  '+ str(ter + 4) +'  '+ str(ter + 10) +'  '+str(ter+11)+'     4   -173.40     7.11       2' 
        print ' '+str(ter +10) +'  '+ str(ter + 4) +'  '+ str(ter + 15) +'  '+str(ter+18)+'     4   -171.66     7.11       2' 
        print ' '+str(ter +10) +'  '+ str(ter + 4) +'  '+ str(ter + 15) +'  '+str(ter+17)+'     4     68.61     7.11       2' 
        print ' '+str(ter +10) +'  '+ str(ter + 4) +'  '+ str(ter + 15) +'  '+str(ter+16)+'     4    -50.70     7.11       2' 
        print ' '+str(ter +11) +'  '+ str(ter + 10) +'  '+ str(ter + 13) +'  '+str(ter+14)+'     4    177.45     7.11       2' 
        print ' '+str(ter +11) +'  '+ str(ter + 10) +'  '+ str(ter + 4) +'  '+str(ter+15)+'     4    -55.37     7.11       2' 
        print ' '+str(ter +12) +'  '+ str(ter + 10) +'  '+ str(ter + 13) +'  '+str(ter+14)+'     4    -66.23     7.11       2' 
        print ' '+str(ter +12) +'  '+ str(ter + 10) +'  '+ str(ter + 4) +'  '+str(ter+15)+'     4   -174.67     7.11       2' 
        print ' '+str(ter +13) +'  '+ str(ter + 10) +'  '+ str(ter + 4) +'  '+str(ter+15)+'     4    61.64      7.11       2' 

        print ';LIGAND PROTEIN Should be fine!!!!'
        print ' '+str(ter + 1) +'  '+ str(og_index) +'  '+ str(cb_index) +'  '+str(ca_index)+'     4     88.37     1.26       2'
        print ' '+str(ter + 1) +'  '+ str(og_index) +'  '+ str(cb_index) +'  '+str(hb1_index)+'     4    -36.79     1.26       2'
        print ' '+str(ter + 1) +'  '+ str(og_index) +'  '+ str(cb_index) +'  '+str(hb2_index)+'     4    -154.46    1.26       2'
        print ' '+str(ter + 2) +'  '+ str(ter + 1) +'  '+ str(og_index) +'  '+str(cb_index)+'     4    -36.53     7.11       2'
        print ' '+str(ter + 3) +'  '+ str(ter + 1) +'  '+ str(og_index) +'  '+str(cb_index)+'     4    -159.39    7.11       2' 
        print ' '+str(ter + 4) +'  '+ str(ter + 1) +'  '+ str(og_index) +'  '+str(cb_index)+'     4     91.77     7.11       2' 
        print ' '+str(ter + 8) +'  '+ str(ter + 3) +'  '+ str(ter + 1) +'  '+str(og_index)+'     4     95.68     7.11       2' 
        print ' '+str(ter + 9) +'  '+ str(ter + 4) +'  '+ str(ter + 1) +'  '+str(og_index)+'     4    -60.36     7.11       2' 
        print ' '+str(ter +10) +'  '+ str(ter + 4) +'  '+ str(ter + 1) +'  '+str(og_index)+'     4     56.08     7.11       2' 
        print ' '+str(ter +15) +'  '+ str(ter + 4) +'  '+ str(ter + 1) +'  '+str(og_index)+'     4    -176.83    7.11       2' 

    if shall_distance_restraints:
        if i == disres - 3:
            og_index = ser + 7
            c4_index = ter + 1 
            c6_index = ter +  8
            o5_index = ter + 3
            o4_index = ter + 2

            print '[ exclusions ]'  
            print str(c4_index) + " "+str(og_index)
            print str(og_index) + " "+str(c4_index)
            print
            print "[ distance_restraints ]"
            print "; ai aj type index type' low up1 up2 fac"
            print str(c4_index) + " " + str(og_index) + "  1    0    2    0.0 0.3 0.4 2.0" #full distance restraint like covalent bonf fc =476976.0
            print str(c6_index) + " " + str(og_index) + "  1    1    2    0.0 0.3 0.4 1." #half the distant restraint
            print str(o4_index) + " " + str(og_index) + "  1    2    2    0.0 0.3 0.4 1."
            print str(o5_index) + " " + str(og_index) + "  1    3    2    0.0 0.3 0.4 1."
            

            #print '[ constraints ]'
            #print '; ai aj funct length_A length_B'
            #print str(c4_index) + " "+str(og_index) + ' 2 0.144 1.144'
